﻿var lang = {
	"en": {
		"pickMedia": "Pick media from Mediaflow",
		"removeMedia": "Remove media",
		"clickHere": "Click here to add media",
		"addFromMediaflow": "Add from Mediaflow",
	},
	"sv": {
		"pickMedia": "Välj media från Mediaflow",
		"removeMedia": "Ta bort media",
		"clickHere": "Click here to add media",
		"addFromMediaflow": "Add from Mediaflow",
	}
};

define(
	[
		"epi-cms/widget/_HasChildDialogMixin",
		"dojo/_base/declare",
		"dijit/_Widget",
		"dijit/_TemplatedMixin",
		"dojo/html",

		"epi/_Module",
		"epi/dependency",
		"epi/routes",
		"epi/shell/_ContextMixin"
	],
	function (
		_HasChildDialogMixin,
		declare,
		_Widget,
		_TemplatedMixin,
		html,

		//CMS
		_Module,
		dependency,
		routes,
		_ContextMixin
	) {
		return declare([_Widget, _TemplatedMixin, _HasChildDialogMixin, _ContextMixin],
			{
				// templateString: [protected] String
				// A string that represents the default widget template.
				templateString: '<div class="dijitInline"><div style="cursor:pointer;" data-dojo-attach-point="bbild"></div><div style=\"cursor:pointer\" data-dojo-attach-point=\"bortbild\"></div></div>',

				constructor: function () {
					var context = this.getCurrentContext();
					var currentLang = context.language.indexOf('sv') > -1 ? 'sv' : 'en';

					this.currentLang = currentLang;
					this.lang = lang[currentLang];
				},
				_setValueAttr: function (value) {

					if (value) {
						this._set('value', value);
					}

					if (value && value.type == 'video') {
						var _this = this;
						setTimeout(() => {
							html.set(_this.bbild, '<img src="https://m.mediaflow.com/poster/' + value.mediaId + '?w=192&h=108" style="max-width: 300px;" />');
							html.set(_this.bortbild, _this.lang.removeMedia);
						}, 5);
					} else if (value && value.type == 'image') {
						var _this = this;
						setTimeout(() => {
							html.set(_this.bbild, '<img src="' + value.fileUrl + '" style="max-width: 300px;" />');
							html.set(_this.bortbild, _this.lang.removeMedia);

						}, 5);
					} else {
						html.set(this.bbild, this.lang.clickHere);
						html.set(this.bortbild, '');
					}
				},

				postCreate: function () {
					var userProfile = dependency.resolve("epi.shell.Profile");
					this.username = userProfile.userName;

					// summary : Connects keyboard events of the email textbox to update the value of the editor.
					// tags    : protected
					this.connect(this.bbild, 'onclick', this._onClicka);
					this.connect(this.bortbild, 'onclick', this._bortclick);
				},

				_onClicka: function (event) {
					if (this.readOnly) {
						alert('Du har inte behörighet att ändra film');
						return;
					}
					this._showChildDialog();
				},

				_bortclick: function (event) {
					if (this.readOnly) {
						alert(this.m);
						return;
					}
					//if (window.confirm('Är du säker på att du vill ta bort aktuell film?')) {
						var v = { autoPlay: false, mediaID: '', embedCode: '', startAt: 0, embedType: '' };
						this._set('value', v);
						this.onChange(v);
						html.set(this.bbild, this.lang.clickHere);
						html.set(this.bortbild, '');
					//}
				},

				_clickDone: function (o) {
					if (o.basetype == 'image') {
						fetch('/api/mediaflow/upload?imageUrl=' + o.url + '&fileName=' + o.filename).then((r) => r.json().then((data) => {
							var v = { fileId: data.fileId, fileUrl: data.fileUrl, altText: o.altText, embedCode: '', autoPlay: null, mediaId: null, startAt: 0, embedType: null, type: o.basetype, selectedId: o.id, selectedFolder: o.selectedFolder };
							this._set('value', v);

							console.log(this.value)

							this.onChange(v);
							html.set(this.bbild, '<img src="' + data.fileUrl + '" title="' + this.lang.clickHere + '" style="max-width: 300px;" />');
							html.set(this.bortbild, this.lang.removeMedia);
							this._dialog.hide();
						}));
					} else if (o.basetype == 'video') {
						if (!o.mediaId) {
							alert('Ett fel inträffade när filmen skulle sparas (mediaId == null)!');
							this._dialog.hide();
							return;
						}
						var v = { fileId: null, fileUrl: '', altText: o.altText ?? '', type: o.basetype, embedCode: o.embedCode, autoPlay: o.autoPlay, mediaId: o.mediaId, startAt: o.startTime, embedType: o.embedMethod, selectedId: o.id, selectedFolder: o.selectedFolder };
						this._set('value', v);
						this.onChange(v);
						html.set(this.bbild, '<img src="https://m.mediaflow.com/poster/' + v.mediaId + '?w=192&h=108" title="' + this.lang.clickHere + '" />');
						html.set(this.bortbild, this.lang.removeMedia);
						this._dialog.hide();
					}
				},

				_showChildDialog: function () {
					var w, h, dialogurl, mediaID, autoPlay, startAt, embedType, selectedID, selectedFolder;
					if (window.innerHeight) {
						w = window.innerWidth;
						h = window.innerHeight;
					} else {
						h = document.compatMode !== 'BackCompat' ? document.documentElement.clientHeight : document.body.clientHeight;
						w = document.compatMode !== 'BackCompat' ? document.documentElement.clientWidth : document.body.clientWidth;
					}
					mediaID = '';
					if (this.value && this.value.mediaID)
						mediaID = this.value.mediaID;
					autoPlay = '0';
					if (this.value && this.value.autoPlay === true)
						autoPlay = '1';
					startAt = '0';
					if (this.value && this.value.startAt > 0)
						startAt = this.value.startAt;
					embedType = '0';
					if (this.value && this.value.embedType == 'iframe')
						embedType = '1';
					selectedID = '0';
					if (this.value && this.value.selectedID > 0)
						selectedID = this.value.selectedID;
					selectedFolder = '0';
					if (this.value && this.value.selectedFolder > 0)
						selectedFolder = this.value.selectedFolder;

					dialogurl = '/EPiServer/Mediaflow.optimizely/Scripts/mfselector/dialog.html?id=' + this.id + '&mid=' + mediaID + '&ap=' + autoPlay + '&sa=' + startAt + '&et=' + embedType + '&si=' + selectedID + '&sf=' + selectedFolder + '&username=' + this.username + '&lang=' + this.currentLang;
					this._dialog = dijit.Dialog(
						{
							title: this.lang.addFromMediaflow,
							content: '<iframe width="' + (w - 200) + '" height="' + (h - 200) + '" frameborder="0" style="background-color:#000;" src="' + dialogurl + '"></iframe>'
						});
					this.connect(this._dialog, 'onHide', this._onHide);
					this.isShowingChildDialog = true;
					this._dialog.containerNode.style.padding = '0';
					this._dialog.show();
				},

				_onHide: function () {
					this.isShowingChildDialog = false;
				}
			})
	}
);