﻿tinymce.PluginManager.add('mfinsertmedia', function (editor, url) {
    var icon = '<svg style="fill: #595959;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 16 16"><polygon points="0.83 11.42 -0.32 11.43 4.9 3.52 9.38 10.21 8.17 10.19 4.9 5.32 0.83 11.42"/><path d="M13.62,11.64a2.35,2.35,0,0,1-2-1.08l-.26-.38-.83,1.24H9.28l1.49-2.14L9.13,6.81,6.06,11.42H4.84L9.13,5l2.24,3.36L11.66,8a2.34,2.34,0,0,1,2-1,2.37,2.37,0,0,1,0,4.73ZM12,9.27l.49.74a1.37,1.37,0,1,0,0-1.5Z"/></svg>';

    editor.addButton('mfinsertmedia', {
        icon: 'mficon',
        tooltip: "Mediaflow",
        onclick: function () {
            var userProfile = epi.dependency.resolve("epi.shell.Profile");
            var username = userProfile.userName;
            var lang = userProfile.contentLanguage;

            // Open window
            editor.windowManager.open({
                title: 'Mediaflow',
                url: '/ClientResources/Scripts/mfselector/dialog.html?tinymce=true&username='+username+'&lang='+lang,
                width: 1300,
                height: 600,
            });
        },
        onPostRender: function () {
            document.querySelector('.mce-i-mficon').innerHTML = (icon);
        }
    });
    return {
        getMetadata: function () {
            return {
                name: "Mediaflow",
                url: "https://www.mediaflow.com"
            };
        }
    };
});